function love.load()
	love.graphics.setDefaultFilter("nearest", "nearest")
	love.keyboard.setKeyRepeat(true)
	love.filesystem.setIdentity("bat")
	
	maps = love.filesystem.getDirectoryItems("maps")
	currentmap = 1
	
	love.window.setTitle("Bat Mini Game")
	
	while string.sub(maps[currentmap], -4, -1) ~= ".png" and currentmap <= #maps do
		currentmap = currentmap + 1
	end
	
	imgmap = love.image.newImageData("maps/" .. maps[currentmap])
	
	playerx = 55
	playery = 102
	playerwidth = 10
	playerheight = 10
	
	for x = 0, imgmap:getWidth()-1 do
		local found = false
		for y = 0, imgmap:getHeight()-1 do
			local r, g, b, a = imgmap:getPixel(x, y)
			if r == 0 and g == 0 and b == 255 and a == 255 then
				playerx = x + 1
				playery = y + 1
				found = true
			end
			
			if found then
				break
			end
		end
		if found then
			break
		end
	end
	
	radius = 100
end

function love.update(dt)
	radius = radius + dt * 200
	if radius >= 100 then
		radius = 0
	end
	
	if love.keyboard.isDown("left") == true then
		playerx = playerx - dt * 100
	end
	if love.keyboard.isDown("right") == true then
		playerx = playerx + dt * 100
	end
	if love.keyboard.isDown("up") == true then
		playery = playery - dt * 100
	end
	if love.keyboard.isDown("down") == true then
		playery = playery + dt * 100
	end
	
	local tmpr, tmpg, tmpb, tmpa
	tmpr, tmpg, tmpb, tmpa = imgmap:getPixel(playerx + playerwidth / 2, playery + playerheight / 2)
	if tmpr == 0 and tmpg == 0 and tmpb == 0 then
		playerx = 55
		playery = 102
	elseif tmpr == 255 and tmpg == 0 and tmpb == 0 then
		currentmap = currentmap + 1
		print("maps[currentmap] = " .. maps[currentmap])
		while currentmap <= #maps and string.sub(maps[currentmap], -4, -1) ~= ".png" do
			currentmap = currentmap + 1
		end
		
		if currentmap <= #maps then
			imgmap = love.image.newImageData("maps/" .. maps[currentmap])
			playerx = 55
			playery = 102
			
			for x = 0, imgmap:getWidth()-1 do
				local found = false
				for y = 0, imgmap:getHeight()-1 do
					local r, g, b, a = imgmap:getPixel(x, y)
					if r == 0 and g == 0 and b == 255 and a == 255 then
						playerx = x + 1
						playery = y + 1
						found = true
					end
					
					if found then
						break
					end
				end
				if found then
					break
				end
			end
		else
			love.event.quit()
		end
	end
end

function drawpoint(x, y)
	local tmpr, tmpg, tmpb, tmpa
	if (x < 1) or (x >= 800 - 1) or (y < 1) or (y >= 600 - 1) then
		
	else
		tmpr, tmpg, tmpb, tmpa = imgmap:getPixel(x, y)
		if tmpr == 255 and tmpg == 255 and tmpb == 255 then
			love.graphics.setColor(255, 255, 255)
		elseif tmpr == 0 and tmpg == 0 and tmpb == 0 then
			love.graphics.setColor(0, 0, 0)
		elseif tmpr == 255 and tmpg == 0 and tmpb == 0 then
			love.graphics.setColor(255, 0, 0)
		end
		
		love.graphics.point(x, y)
	end
end

function love.draw()
	local x0 = playerx + playerwidth / 2
	local y0 = playery + playerheight / 2

	local x = radius
	local y = 0
	local radiuserr = 1 - x

	while(x >= y) do
		drawpoint(x + x0, y + y0)
		drawpoint(y + x0, x + y0)
		drawpoint(-x + x0, y + y0)
		drawpoint(-y + x0, x + y0)
		drawpoint(-x + x0, -y + y0)
		drawpoint(-y + x0, -x + y0)
		drawpoint(x + x0, -y + y0)
		drawpoint(y + x0, -x + y0)
		y = y + 1
		
		if(radiuserr < 0) then
			radiuserr = radiuserr + 2 * y + 1
		else
			x = x - 1
			radiuserr = radiuserr + 2 * (y - x + 1)
		end
	end
	
	love.graphics.setColor(255, 255, 255)
	love.graphics.rectangle("fill", playerx, playery, playerwidth, playerheight)
end

function love.keypressed(key)
	if key == "escape" then
		love.event.quit()
	end
end